/************************************************/
//    Synthesize Desktop Picture
/************************************************/

var parmCX;
var parmCY;
var parmFR;
var parmFW;
var parmFC;
var parmSD;
var parmRZ;
var parmOP;
var parmRP;
var tempGO;

function init()
{
	if (window.widget)	// always check to make sure that you are running in Dashboard
	{
		createGenericButton(document.getElementById("setButton"),"セット",setDPic);
		createGenericButton(document.getElementById("resetButton"),"再設定",resetDPic);
		createGenericButton(document.getElementById("unsetButton"),"クリア",unsetDPic);
		createGenericButton(document.getElementById("doneButton"),"Done",hidePrefsPre);
		initFramePopup();
		widget.onshow = onshow;
		widget.onhide = onhide;
		widget.onremove = onremove;
	}
}

function onshow()
{
	parmCX = widget.preferenceForKey("parmCX");
	parmCY = widget.preferenceForKey("parmCY");
	parmFR = widget.preferenceForKey("parmFR");
	parmFW = widget.preferenceForKey("parmFW");
	parmFC = widget.preferenceForKey("parmFC");
	parmSD = widget.preferenceForKey("parmSD");
	if (parmCX == null) parmCX = "100";
	document.getElementById("inputText1").value = parmCX;
	if (parmCY == null) parmCY = "100";
	document.getElementById("inputText2").value = parmCY;
	if (parmFR == null) parmFR = true;
	document.getElementById("checkFrame").checked = parmFR;
	if (parmFW == null) parmFW = "6";
	document.getElementById("inputText3").value = parmFW;
	if (parmFC == null) parmFC = "white";
	changeFramePopup();
	if (parmSD == null) parmSD = true;
	document.getElementById("checkShadow").checked = parmSD;
	if (parmRZ == null) parmRZ = true;
	document.getElementById("checkResize").checked = parmRZ;
	parmOP = widget.preferenceForKey("parmOP");
	parmRP = widget.preferenceForKey("parmRP");
}

function onhide()
{
	widget.setPreferenceForKey(document.getElementById("inputText1").value,"parmCX");
	widget.setPreferenceForKey(document.getElementById("inputText2").value,"parmCY");
	widget.setPreferenceForKey(document.getElementById("checkFrame").checked,"parmFR");
	widget.setPreferenceForKey(document.getElementById("inputText3").value,"parmFW");
	widget.setPreferenceForKey(document.getElementById ('frame-popup').options[document.getElementById ('frame-popup').selectedIndex].text,"parmFC");
	widget.setPreferenceForKey(document.getElementById("checkShadow").checked,"parmSD");
	widget.setPreferenceForKey(document.getElementById("checkResize").checked,"parmRZ");
	widget.setPreferenceForKey(parmOP,"parmOP");
	widget.setPreferenceForKey(parmRP,"parmRP");
}

function onremove()
{
	widget.setPreferenceForKey(null,"parmCX");
	widget.setPreferenceForKey(null,"parmCY");
	widget.setPreferenceForKey(null,"parmFR");
	widget.setPreferenceForKey(null,"parmFW");
	widget.setPreferenceForKey(null,"parmFC");
	widget.setPreferenceForKey(null,"parmSD");
	widget.setPreferenceForKey(null,"parmRZ");
	widget.setPreferenceForKey(null,"parmOP");
	widget.setPreferenceForKey(null,"parmRP");
}


function setDPic()
{
	if (tempGO == null)
	{
		tempGO = true;
		setDPic2();
		tempGO = null;
	}
}

function setDPic2()
{
	if (synthDPPlugin)
	{
			var flnam = "synthDP";
			var fpath = widget.system('/usr/bin/osascript AppleScripts/getDfolder.applescript "'+flnam+'"',null).outputString.slice(0,-1);
			if (fpath == "") {
				showMsg("msgText","書き出しフォルダを取得できませんでした。");
				return; }
			var dpath = widget.system('/usr/bin/osascript AppleScripts/getDpath.applescript',null).outputString.slice(0,-1);
			if (dpath == "") {
				showMsg("msgText","現在のデスクトップピクチャを取得できませんでした。");
				return; }
			var spath = widget.system('/usr/bin/osascript AppleScripts/getSpath.applescript',null).outputString.slice(0,-1);
			if (spath == "") {
				showMsg("msgText","配置画像を取得できませんでした。");
				return; }
			var rpath = getRpath(fpath,dpath);
			var fval = document.getElementById("inputText3").value;
			if (!document.getElementById("checkFrame").checked) fval = 0;
			var rcode = synthDPPlugin.synthPicture(document.getElementById("inputText1").value,document.getElementById("inputText2").value,fval,document.getElementById ('frame-popup').options[document.getElementById ('frame-popup').selectedIndex].text,document.getElementById("checkShadow").checked,"8.0","8.0","12.0","black",document.getElementById("checkResize").checked,spath,dpath,rpath);
			switch (parseInt(rcode))
			{
				case 0:
					var rcod2 = widget.system('/usr/bin/osascript AppleScripts/setDpict.applescript "'+rpath+'"',null).outputString.slice(0,-1);
					switch (parseInt(rcod2))
					{
						case 0:
							showMsg("msgText","正常にセットされました。");
							parmRP = rpath;
							parmOP = dpath;
							break;
						default:
							showMsg("msgText","予期しないエラーが発生しました。("+rcod2+")");
							break;
					}
					break;
				case 1:
					showMsg("msgText","背景画像を読み込めませんでした。");
					break;
				case 2:
					showMsg("msgText","配置画像を読み込めませんでした。");
					break;
				default:
					showMsg("msgText","予期しないエラーが発生しました。("+rcode+")");
					break;
			}
	} else {
		showMsg("msgText","Widget plugin not loaded.");
	}
}

function getRpath(fpath,dpath)
{
	var st_array = dpath.split("/");
	var fnameA = st_array[st_array.length-1];
	st_array = fnameA.split(".");
	var fnameE = st_array[st_array.length-1];
	var fnameB = fnameA.slice(0,-(fnameE.length+1));
	var rpath = fpath + fnameB + ".jpg";
	return rpath;
}

function resetDPic()
{
	if (parmRP == null)
	{
		showMsg("msgText","まだセットされていないので、再設定できません。");
	} else {
		var rcod = widget.system('/usr/bin/osascript AppleScripts/setDpict.applescript "'+parmRP+'"',null).outputString;
		showMsg("msgText","正常に再セットされました。");
	}
}

function unsetDPic()
{
	if (parmOP == null)
	{
		showMsg("msgText","まだセットされていないので、クリアできません。");
	} else {
		var rcod = widget.system('/usr/bin/osascript AppleScripts/setDpict.applescript "'+parmOP+'"',null).outputString;
		showMsg("msgText","正常にクリアされました。");
	}

}

function initFramePopup()
{
	var i, element;
	document.getElementById("tempText").innerHTML = "black;blue;brown;cyan;darkGray;gray;green;lightGray;magenta;orange;purple;red;white;yellow;";
	var st_array = document.getElementById("tempText").innerHTML.split(";")
	var select = document.getElementById('frame-popup');
	var c = st_array.length - 1;
	for (i = 0; i < c; i++)
	{
		element = document.createElement("option");
		element.innerText = st_array[i];
		select.appendChild(element);
	}
}

function changeFramePopup()
{
	var i, pos;
	var select = document.getElementById('frame-popup');
	var c = select.length;
	for (i = 0; i < c; i++)
	{
		if (select.options[i].text == parmFC) pos = i;
	}
	select.selectedIndex = pos;
}

function hidePrefsPre()
{
	var val;
	val = parseInt(document.getElementById("inputText1").value);
	if (val<0 || val>5000)
	{
		showMsg("msgTextR","x座標の値が不正です。");
		return;
	}
	val = parseInt(document.getElementById("inputText2").value);
	if (val<0 || val>5000)
	{
		showMsg("msgTextR","y座標の値が不正です。");
		return;
	}
	val = parseInt(document.getElementById("inputText3").value);
	if (val<0 || val>30)
	{
		showMsg("msgTextR","縁幅の値が不正です。");
		return;
	}

	hidePrefs()
}

function showMsg(element,mes)
{
	document.getElementById(element).innerHTML = mes;
	textFadeout(element);
}

function showReadme()
{
	widget.system("/usr/bin/open synthDP.rtf",null);
}

/*********************************/
// FADEOUT INFOMATION-MESSAGE
/*********************************/

// A structure that holds information that is needed for the animation to run.
var animation2 = {duration:0, starttime:0, to:1.0, now:1.0, from:0.0, firstElement:null, timer:null};

function textFadeout(element)
{
		// fade in the flip widget
		if (animation2.timer != null)
		{
			clearInterval (animation2.timer);
			animation2.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation2.duration = 2000;
		animation2.starttime = starttime;
		animation2.firstElement = document.getElementById (element);
		animation2.timer = setInterval ("animate2();", 13);
		animation2.from = 1.0;
		animation2.to = 0.0;
		animate2();

}

function animate2()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation2.starttime, 0, animation2.duration);
	
	if (T >= animation2.duration)
	{
		clearInterval (animation2.timer);
		animation2.timer = null;
		animation2.now = animation2.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation2.duration));
		animation2.now = computeNextFloat (animation2.from, animation2.to, ease);
	}
	
	animation2.firstElement.style.opacity = animation2.now;
}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");	// freezes the widget so that you can change it without the user noticing
	
	front.style.display = "none";	// hide the front
	back.style.display = "block";	// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';	// clean up the front side - hide the circle behind the info button
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");	// freezes the widget and prepares it for the flip back to the front
	
	back.style.display = "none";		// hide the back
	front.style.display = "block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	// and flip the widget back to the front
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)	// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)	// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;		// set it back one frame
		
		animation.duration = 500;					// animation time, in ms
		animation.starttime = starttime;				// specify the start time
		animation.firstElement = document.getElementById ('flip');	// specify the element to fade
		animation.timer = setInterval ("animate();", 13);		// set the animation function
		animation.from = animation.now;					// beginning opacity (not ness. 0)
		animation.to = 1.0;						// final opacity
		animate();							// begin animation
		flipShown = true;						// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}
